module.exports = {
	env: {
		node: true,
		commonjs: true,
		es6: true,
	},
	extends: 'eslint:recommended',
	globals: {
		Atomics: 'readonly',
		SharedArrayBuffer: 'readonly',
	},
	parserOptions: {
		ecmaVersion: 2018,
	},
	rules: {
		'accessor-pairs': 'error',
		'array-bracket-newline': 'off',
		'array-bracket-spacing': ['error', 'never'],
		'array-callback-return': 'error',
		'array-element-newline': 'off',
		'arrow-body-style': 'off',
		'arrow-parens': 'off',
		'arrow-spacing': 'off',
		'block-scoped-var': 'error',
		'block-spacing': ['error', 'always'],
		'brace-style': 'off',
		'callback-return': 'off',
		camelcase: 'off',
		'capitalized-comments': 'off',
		'class-methods-use-this': 'error',
		'comma-dangle': 'off',
		'comma-spacing': 'off',
		'comma-style': 'off',
		complexity: 'off',
		'computed-property-spacing': ['error', 'never'],
		'consistent-return': 'off',
		'consistent-this': 'error',
		curly: 'off',
		'default-case': 'error',
		'default-param-last': 'error',
		'dot-location': ['error', 'property'],
		'dot-notation': 'off',
		'eol-last': 'off',
		eqeqeq: 'off',
		'func-call-spacing': 'error',
		'func-name-matching': 'error',
		'func-names': 'off',
		'func-style': 'off',
		'function-call-argument-newline': ['error', 'consistent'],
		'function-paren-newline': 'off',
		'generator-star-spacing': 'error',
		'global-require': 'error',
		'grouped-accessor-pairs': 'error',
		'guard-for-in': 'error',
		'handle-callback-err': 'off',
		'id-blacklist': 'error',
		'id-length': 'off',
		'id-match': 'error',
		'implicit-arrow-linebreak': ['error', 'beside'],
		indent: 'off',
		'indent-legacy': 'off',
		'init-declarations': 'off',
		'jsx-quotes': 'error',
		'key-spacing': 'off',
		'keyword-spacing': 'off',
		'line-comment-position': 'error',
		'linebreak-style': ['error', 'unix'],
		'lines-around-comment': 'error',
		'lines-around-directive': 'error',
		'lines-between-class-members': 'error',
		'max-classes-per-file': 'error',
		'max-depth': 'off',
		'max-len': 'off',
		'max-lines': 'error',
		'max-lines-per-function': 'off',
		'max-nested-callbacks': 'error',
		'max-params': 'error',
		'max-statements': 'off',
		'max-statements-per-line': 'off',
		'multiline-comment-style': ['error', 'separate-lines'],
		'multiline-ternary': 'error',
		'new-parens': 'error',
		'newline-after-var': 'off',
		'newline-before-return': 'off',
		'newline-per-chained-call': 'off',
		'no-alert': 'error',
		'no-array-constructor': 'error',
		'no-await-in-loop': 'off',
		'no-bitwise': 'error',
		'no-buffer-constructor': 'error',
		'no-caller': 'error',
		'no-catch-shadow': 'error',
		'no-confusing-arrow': 'error',
		'no-console': 'off',
		'no-constructor-return': 'error',
		'no-continue': 'off',
		'no-div-regex': 'error',
		'no-dupe-else-if': 'error',
		'no-duplicate-imports': 'error',
		'no-else-return': 'off',
		'no-empty': [
			'error',
			{
				allowEmptyCatch: true,
			},
		],
		'no-empty-function': 'error',
		'no-eq-null': 'error',
		'no-eval': 'error',
		'no-extend-native': 'error',
		'no-extra-bind': 'error',
		'no-extra-label': 'error',
		'no-extra-parens': 'off',
		'no-floating-decimal': 'error',
		'no-implicit-coercion': 'error',
		'no-implicit-globals': 'error',
		'no-implied-eval': 'error',
		'no-import-assign': 'error',
		'no-inline-comments': 'error',
		'no-invalid-this': 'error',
		'no-iterator': 'error',
		'no-label-var': 'error',
		'no-labels': 'error',
		'no-lone-blocks': 'error',
		'no-lonely-if': 'off',
		'no-loop-func': 'error',
		'no-magic-numbers': 'off',
		'no-mixed-operators': 'error',
		'no-mixed-requires': 'error',
		'no-multi-assign': 'error',
		'no-multi-spaces': 'off',
		'no-multi-str': 'error',
		'no-multiple-empty-lines': 'off',
		'no-native-reassign': 'error',
		'no-negated-condition': 'error',
		'no-negated-in-lhs': 'error',
		'no-nested-ternary': 'error',
		'no-new': 'error',
		'no-new-func': 'error',
		'no-new-object': 'error',
		'no-new-require': 'error',
		'no-new-wrappers': 'error',
		'no-octal-escape': 'error',
		'no-param-reassign': 'off',
		'no-path-concat': 'error',
		'no-plusplus': 'error',
		'no-process-env': 'off',
		'no-process-exit': 'error',
		'no-proto': 'error',
		'no-restricted-globals': 'error',
		'no-restricted-imports': 'error',
		'no-restricted-modules': 'error',
		'no-restricted-properties': 'error',
		'no-restricted-syntax': 'error',
		'no-return-assign': 'error',
		'no-return-await': 'off',
		'no-script-url': 'error',
		'no-self-compare': 'error',
		'no-sequences': 'error',
		'no-setter-return': 'error',
		'no-shadow': 'off',
		'no-spaced-func': 'error',
		'no-sync': 'error',
		'no-tabs': [
			'error',
			{
				allowIndentationTabs: true,
			},
		],
		'no-template-curly-in-string': 'error',
		'no-ternary': 'off',
		'no-throw-literal': 'error',
		'no-trailing-spaces': 'off',
		'no-undef-init': 'error',
		'no-undefined': 'off',
		'no-underscore-dangle': 'off',
		'no-unmodified-loop-condition': 'error',
		'no-unneeded-ternary': 'error',
		'no-unused-expressions': 'off',
		'no-use-before-define': 'error',
		'no-useless-call': 'error',
		'no-useless-computed-key': 'error',
		'no-useless-concat': 'error',
		'no-useless-constructor': 'error',
		'no-useless-rename': 'error',
		'no-useless-return': 'off',
		'no-var': 'off',
		'no-void': 'error',
		'no-warning-comments': 'error',
		'no-whitespace-before-property': 'error',
		'nonblock-statement-body-position': ['error', 'any'],
		'object-curly-newline': 'error',
		'object-curly-spacing': 'off',
		'object-shorthand': 'off',
		'one-var': 'off',
		'one-var-declaration-per-line': 'error',
		'operator-assignment': ['error', 'always'],
		'operator-linebreak': ['error', null],
		'padded-blocks': 'off',
		'padding-line-between-statements': 'error',
		'prefer-arrow-callback': 'off',
		'prefer-const': 'off',
		'prefer-destructuring': 'off',
		'prefer-exponentiation-operator': 'error',
		'prefer-named-capture-group': 'error',
		'prefer-numeric-literals': 'error',
		'prefer-object-spread': 'error',
		'prefer-promise-reject-errors': 'off',
		'prefer-reflect': 'off',
		'prefer-regex-literals': 'error',
		'prefer-rest-params': 'error',
		'prefer-spread': 'error',
		'prefer-template': 'off',
		'quote-props': 'off',
		quotes: 'off',
		radix: ['error', 'as-needed'],
		'require-atomic-updates': 'off',
		'require-await': 'off',
		'require-jsdoc': 'off',
		'require-unicode-regexp': 'error',
		'rest-spread-spacing': ['error', 'never'],
		semi: 'off',
		'semi-spacing': 'error',
		'semi-style': ['error', 'last'],
		'sort-imports': 'error',
		'sort-keys': 'off',
		'sort-vars': 'error',
		'space-before-blocks': 'off',
		'space-before-function-paren': 'off',
		'space-in-parens': 'off',
		'space-infix-ops': 'off',
		'space-unary-ops': 'error',
		'spaced-comment': 'off',
		strict: ['error', 'never'],
		'switch-colon-spacing': 'error',
		'symbol-description': 'error',
		'template-curly-spacing': ['error', 'never'],
		'template-tag-spacing': 'error',
		'unicode-bom': ['error', 'never'],
		'valid-jsdoc': 'off',
		'vars-on-top': 'off',
		'wrap-iife': 'error',
		'wrap-regex': 'error',
		'yield-star-spacing': 'error',
		yoda: ['error', 'never'],
	},
};
